/*
 * File: HappyBirthday.java
 * =================================================
 * A program that shows off the "birthday paradox:"
 * not very many people need to be in a room to
 * have a high chance that two of them share a
 * birthday.
 */

import acm.program.*;
import acm.util.*;

public class HappyBirthday extends ConsoleProgram {
	/* Number of days in the year.  We'll include leap years. */
	private static final int NUM_DAYS = 366;
	
	public void run() {
		/* Happy birthday!  Have a large font! */
		setFont("DejaVuSerif-BOLD-24");
		RandomGenerator rgen = RandomGenerator.getInstance();
		
		/* Track which days have been used. */
		boolean[] used = new boolean[NUM_DAYS];
		
		/* Count how many people we've needed. */
		int numPeople = 0;
		
		while (true) {
			/* Pick another person. */
			numPeople++;
			int birthday = rgen.nextInt(0, NUM_DAYS - 1);
			
			/* See if their birthday was used. */
			if (used[birthday] == true) break;
			
			used[birthday] = true;
		}
		
		println("We needed " + numPeople + " people.");
	}
}
