import acm.program.*;

public class SoundWarper extends ConsoleProgram {
	
	/**
	 * Given a sound wave, slows the sound wave down by doubling
	 * the length of that sound clip.
	 *
	 * @param sound The sound clip to slow down.
	 * @return A slower version of that soudn clip.
	 */
	private double[] slowDown(double[] sound) {
		double[] result = new double[sound.length * 2];
		
		for (int i = 0; i < sound.length; i++) {
			result[2 * i] = sound[i];
			result[2 * i + 1] = sound[i];
		}
		
		return result;
	}
	
	/**
	 * Reverses the given sound clip.
	 *
	 * @param sound The sound clip to reverse.
	 * @return A reversed copy of the sound clip.
	 */
	private double[] reverseSound(double[] sound) {
		double[] result = new double[sound.length];
		
		for (int i = 0; i < result.length; i++) {
			result[i] = sound[sound.length - 1 - i];
		}
		
		return result;
	}
	
	public void run() {		
		double[] sound = StdAudio.read("clocks.wav");
		StdAudio.play(reverseSound(sound));
	}
}
